/*
//	BMP.h	( Windows 3.0 uncompressed format only )
//
//	based on

 * bmp.h - routines to calculate sizes of parts of BMP files
 *
 * Some fields in BMP files contain offsets to other parts
 * of the file.  These routines allow us to calculate these
 * offsets, so that we can read and write BMP files without
 * the need to fseek().
 * 
 * Copyright (C) 1992 by David W. Sanderson.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear
 * in supporting documentation.  This software is provided "as is"
 * without express or implied warranty.
 * 
 * Revision 1.3  1992/11/24  19:39:56  dws
//
*/

#ifndef _BMP_H_
#define _BMP_H_

#define	BMPlenfileheader 14
#define	BMPleninfoheader 40

	typedef struct{
		struct {
			char	head1;
			char	head2;
			long	cbSize;
			short	xHotSpot;
			short	yHotSpot;
			long	offBits;
		} file;
		struct{
			long	cbFix;
			long	cx;
			long	cy;
			short	cPlanes;
			short	cBitCount;
			long	filler[6];
		} info;
	} BMPHEADER;

	typedef struct{
		unsigned char	b;
		unsigned char	g;
		unsigned char	r;
		unsigned char	filler;
	} RGBQUAD;

/*
 * Utilities
 */

#define	BMPlenrgbtable( bitcount ) (\
		 (bitcount == 24 )? 0:( ( 1 << bitcount ) * 4 ) \
	)

/*
 * length, in bytes, of a line of the image
 * 
 * Evidently each row is padded on the right as needed to make it a
 * multiple of 4 bytes long.  This appears to be true of both
 * OS/2 and Windows BMP files.
 */
#define	BMPlenline( bitcount, x ) (\
		 ( ( bitcount * x + 31 ) >> 3 ) & 0xfffffffc \
	 )


/* return the offset to the BMP image bits */
#define	BMPoffbits( bitcount) (\
		BMPlenfileheader + BMPleninfoheader + BMPlenrgbtable( bitcount ) \
	)

/* return the size of the BMP file in bytes */
#define	BMPlenfile( bitcount, x, y ) (\
		BMPoffbits( bitcount ) + y * BMPlenline( bitcount, x ) \
	)

/* prototypes */
void	BMPSave();
void	BMPLoad();

#endif /* _BMP_H_ */
