/*
//	PPM.cc -- ppm,pgm$@%U%)!<%^%C%H2hA|$r07$&(J
//
//		created    in 3/22/1993
//		revised    in 2/12/1994
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	"defs.h"
#include	"PPM.h"

static void	SkipSpace()
{
    int 	c;

    for ( ;; ) {
	if ( (c = fgetc (fp)) != ' ' && c != '\t' && c != '\n' && c != '\r' && c != '#' ) {
	    ungetc( c, fp );
	    return;
	}
	if ( c == '#' ) {
	    for ( ;; ) {
		if ( (c = fgetc (fp)) == '\n' || c == EOF )
		    break;
	    }
	}
    }
}

static int 	GetInteger()
{
    int 	c, Value;

    SkipSpace();
    Value = 0;
    for ( ;; ) {
	if ( !isdigit (c = fgetc (fp)) )
	    return Value;
	Value = Value * 10 + c - '0';
    }
}

void	init_multbl( tbl, max )
unsigned char	*tbl;
int	max;
{
	int	i;

	for( i= 0; i < max; i++ )
		*tbl++= i * 32 / max;
}

void	PPMLoad()
{
    int 	c, MaxColor, i, HalfSize;
    int		r, g, b;
	unsigned char	multbl[256];

    if ( fp == NULL && (fp = fopen( File, "rb" )) == NULL )
	error ("No such file");
    if ( fgetc (fp) != 'P' )
	error ("Is not ppm format");
    if ( (c = fgetc (fp)) != '3' && c != '6' )
	error ("Is not ppm format");
    Width = GetInteger();
    Height = GetInteger();
    MaxColor = GetInteger();
	if( OutBpp == 2 ){
		AllocateScreen();
	}else {
		AllocateScreen24();
	}
    MaxColor++;
    HalfSize = Size / 2;
    if ( c == '3' ) {
		if( OutBpp == 2 ){
			init_multbl( multbl, MaxColor );
			for ( i = 0; i < HalfSize; i++ ) {
				r = multbl[GetInteger()];
				g = multbl[GetInteger()];
				b = multbl[GetInteger()];
				Screen[i] = (r << 5) | (g << 10) | b;
			}
		}
		else
			for ( i = 0; i < HalfSize * 3; i++ )
				Screen[i] = ((GetInteger()) * 32) / MaxColor;
    }
    else {
		if( OutBpp == 2 )
			if( MaxColor == 256 ){
				for ( i = 0; i < HalfSize; i++ ) {
					r = fgetc (fp) >> 3;
					g = fgetc (fp) >> 3;
					b = fgetc (fp) >> 3;
					Screen[i] = (r << 5) | (g << 10) | b;
				}
			}else {
				init_multbl( multbl, MaxColor );
				for ( i = 0; i < HalfSize; i++ ) {
					r = multbl[fgetc (fp)];
					g = multbl[fgetc (fp)];
					b = multbl[fgetc (fp)];
					Screen[i] = (r << 5) | (g << 10) | b;
				}
			}
		else
			fread( Screen, 1, HalfSize * 3, fp );
    }
    if ( fp != stdin )
	fclose (fp);
    MaxColorGuaranteed = 32768;
	if( OutBpp == 2 )	InBpp= 2;
}

void	PPMSave()
{
	int	HalfSize, i;

	if ( fp == NULL && (fp = fopen( File, "wb" )) == NULL )
		error ("Cannot create");
	HalfSize = Width * Height;
	fprintf( fp, "P6\n%d %d\n255\n", Width, Height );
	if( InBpp == 1 )
		for ( i = 0; i < HalfSize; i++ ) {
			fputc( Red[Screen[i]], fp );
			fputc( Green[Screen[i]], fp );
			fputc( Blue[Screen[i]], fp );
	 	}
	else if( InBpp == 2 )
		for ( i = 0; i < HalfSize; i++ ) {
			unsigned char	r, g, b;
			r = ( Screen[i] >> 2 ) & 0xf8;
			if( r & 8 )	r|= 7;
			g = ( Screen[i] >> 7 ) & 0xf8;
			if( g & 8 )	g|= 7;
			b = Screen[i] << 3;
			if( b & 8 )	b|= 7;
			fputc( r, fp );
			fputc( g, fp );
			fputc( b, fp );
		}
	else
		fwrite( Screen, 1, HalfSize * 3, fp );

    if ( fp != stdout )
	fclose (fp);
}

void	PBMLoad()
{
    int 	c, i, HalfSize, x, y;
	int16	on;

    if ( fp == NULL && (fp = fopen( File, "rb" )) == NULL )
	error ("No such file");
    if ( fgetc (fp) != 'P' )
	error ("Is not pbm format");
    if ( (c = fgetc (fp)) != '1' && c != '4' )
	error ("Is not pbm format");
    Width = GetInteger();
    Height = GetInteger();
    AllocateScreen();
    HalfSize = Size / 2;
	on = ( OutBpp == 2 )? 0x7fff:1;
    if ( c == '1' ) {
	for ( i = 0; i < HalfSize; i++ ) {
	    if ( GetInteger() != 0 ) 
		Screen[i] = 0;
	    else
		Screen[i] = on;
	}
    }
    else {
	for ( y = 0; y < Height; y++ ) {
	    for ( x = 0; x < Width; x += 8 ) {
		c = fgetc (fp);
		for ( i = 0; i < 8; i++ ) {
		    if ( BitField[i] & c )
			Screen[x + i + y * Width] = 0;
		    else
			Screen[x + i + y * Width] = on;
		}
	    }
	}
    }
    if ( fp != stdin )
	fclose (fp);
	Red[0]= 0;
	Green[0]= 0;
	Blue[0]= 0;
	Red[1]= 255;
	Green[1]= 255;
	Blue[1]= 255;
	MaxColorGuaranteed = 2;
	InBpp = ( OutBpp == 2 ) + 1;
}
